Imports System.Data

Partial Class _Default
    Inherits System.Web.UI.Page

#Region "Page Load"

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.GridView1.DataSource = GetData()
            Me.GridView1.DataBind()
            Me.DataList1.DataSource = GetData()
            Me.DataList1.DataBind()
            Me.ListBox1.DataSource = GetData()
            Me.ListBox1.DataBind()
            SetupListBoxEvents(Me.ListBox1)
        End If
    End Sub

#End Region

#Region "GridView1"

    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs) Handles GridView1.RowDataBound
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            If ((e.Row.RowState = DataControlRowState.Edit) _
                        OrElse (e.Row.RowState = (DataControlRowState.Edit Or DataControlRowState.Alternate))) Then
                e.Row.Attributes.Clear()
            Else
                Dim cellIndex As Integer = 2
                Do While (cellIndex < e.Row.Cells.Count)
                    ' Get the LinkButton control in the first cell
                    Dim _singleClickButton As LinkButton = CType(e.Row.Cells(0).Controls(0), LinkButton)
                    ' Get the javascript which is assigned to this LinkButton
                    Dim _jsSingle As String = ClientScript.GetPostBackClientHyperlink(_singleClickButton, "")
                    ' Add the cell index as the event argument parameter
                    _jsSingle = _jsSingle.Insert((_jsSingle.Length - 2), cellIndex.ToString)
                    ' To prevent the first click from posting back immediately 
                    ' (therefore giving the user a chance to double click) pause the 
                    ' postback for 300 milliseconds by using setTimeout
                    _jsSingle = _jsSingle.Insert(11, "setTimeout(""")
                    _jsSingle = (_jsSingle + """, 300)")
                    ' Add this javascript to the onclick Attribute of the row
                    e.Row.Cells(cellIndex).Attributes("onclick") = _jsSingle
                    ' Get the LinkButton control in the second cell
                    Dim _doubleClickButton As LinkButton = CType(e.Row.Cells(1).Controls(0), LinkButton)
                    ' Get the javascript which is assigned to this LinkButton
                    Dim _jsDouble As String = ClientScript.GetPostBackClientHyperlink(_doubleClickButton, "")
                    ' Add the cell index as the event argument parameter
                    _jsDouble = _jsDouble.Insert((_jsDouble.Length - 2), cellIndex.ToString)
                    ' Add this javascript to the ondblclick Attribute of the row
                    e.Row.Cells(cellIndex).Attributes("ondblclick") = _jsDouble
                    cellIndex = (cellIndex + 1)
                Loop
            End If
        End If
    End Sub

    Protected Sub GridView1_RowCommand(ByVal sender As Object, ByVal e As GridViewCommandEventArgs) Handles GridView1.RowCommand
        Dim _gridView As GridView = CType(sender, GridView)
        _gridView.EditIndex = -1
        ' Get the selected index and the command name
        Dim _selectedIndex As Integer = Integer.Parse(e.CommandArgument.ToString)
        Dim _commandName As String = e.CommandName
        Dim _eventArgument As String = Request.Form("__EVENTARGUMENT")
        Select Case (_commandName)
            Case "SingleClick"
                _gridView.SelectedIndex = _selectedIndex
                Me.GridView1.DataSource = GetData()
                Me.GridView1.DataBind()
                Me.Message.Text = (Me.Message.Text + ("Single clicked GridView row at index " _
                            + (_selectedIndex.ToString + (" on cell index " _
                            + (_eventArgument + "<br />")))))
            Case "DoubleClick"
                _gridView.EditIndex = _selectedIndex
                _gridView.SelectedIndex = -1
                Me.GridView1.DataSource = GetData()
                Me.GridView1.DataBind()
                Me.Message.Text = (Me.Message.Text + ("Double clicked GridView row at index " _
                            + (_selectedIndex.ToString + (" on cell index " _
                            + (_eventArgument + "<br />")))))
        End Select
    End Sub

#End Region

#Region "DataList1"

    Protected Sub DataList1_ItemDataBound(ByVal sender As Object, ByVal e As DataListItemEventArgs) Handles DataList1.ItemDataBound
        If ((e.Item.ItemType = ListItemType.Item) _
                    OrElse (e.Item.ItemType = ListItemType.AlternatingItem)) Then
            ' Get the first LinkButton control
            Dim _singleClickButton As LinkButton = CType(e.Item.Controls(1), LinkButton)
            ' Get the javascript which is assigned to this LinkButton
            Dim _jsSingle As String = ClientScript.GetPostBackClientHyperlink(_singleClickButton, "")
            ' To prevent the first click from posting back immediately 
            ' (therefore giving the user a chance to double click) pause the 
            ' postback for 300 milliseconds by using setTimeout
            _jsSingle = _jsSingle.Insert(11, "setTimeout(""")
            _jsSingle = (_jsSingle + """, 300)")
            ' Get the panel wrapping the item
            Dim itemPanelSingle As Panel = CType(e.Item.Controls(5), Panel)
            ' Add this javascript to the onclick Attribute of the panel
            itemPanelSingle.Attributes("onclick") = _jsSingle
            ' Get the second LinkButton control
            Dim _doubleClickButton As LinkButton = CType(e.Item.Controls(3), LinkButton)
            ' Get the javascript which is assigned to this LinkButton
            Dim _jsDouble As String = ClientScript.GetPostBackClientHyperlink(_doubleClickButton, "")
            ' Get the panel wrapping the item
            Dim _itemPanelDouble As Panel = CType(e.Item.Controls(5), Panel)
            ' Add this javascript to the ondblclick Attribute of the panel
            _itemPanelDouble.Attributes("ondblclick") = _jsDouble
        End If
    End Sub

    Protected Sub DataList1_ItemCommand(ByVal source As Object, ByVal e As DataListCommandEventArgs) Handles DataList1.ItemCommand
        Dim _dataList As DataList = CType(source, DataList)
        ' Get the selected index and the command name
        Dim _selectedIndex As Integer = e.Item.ItemIndex
        Dim _commandName As String = e.CommandName
        Select Case (_commandName)
            Case "SingleClick"
                _dataList.SelectedIndex = _selectedIndex
                Me.Message.Text = (Me.Message.Text + ("Single clicked DataList row at index " _
                            + (_selectedIndex.ToString + "<br />")))
            Case "DoubleClick"
                Me.Message.Text = (Me.Message.Text + ("Double clicked DataList row at index " _
                            + (_selectedIndex.ToString + "<br />")))
        End Select
    End Sub

#End Region

#Region "ListBox1"

    Private Sub SetupListBoxEvents(ByVal listBox As ListBox)
        ' Build the javascript for the single click
        Dim _jsSingle As String = ("setTimeout(""__doPostBack('" _
                    + (listBox.UniqueID + "','SingleClick')"", 300)"))
        ' Add the javascript to the onclick Attribute of the ListBox
        listBox.Attributes("onclick") = _jsSingle
        ' Build the javascript for the double click
        Dim _jsDouble As String = ("__doPostBack('" _
                    + (listBox.UniqueID + "','DoubleClick')"))
        ' Add the javascript to the ondblclick Attribute of the ListBox
        listBox.Attributes("ondblclick") = _jsDouble
    End Sub

    Protected Sub ListBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ListBox1.SelectedIndexChanged
        Dim _listBox As ListBox = CType(sender, ListBox)
        ' Get the selected index and the command name
        Dim _selectedIndex As Integer = _listBox.SelectedIndex
        Dim _commandName As String = Request.Form("__EventArgument").ToString
        Select Case (_commandName)
            Case "SingleClick"
                Me.Message.Text = (Me.Message.Text + ("Single clicked ListBox row at index " _
                            + (_selectedIndex.ToString + "<br />")))
            Case "DoubleClick"
                Me.Message.Text = (Me.Message.Text + ("Double clicked ListBox row at index " _
                            + (_selectedIndex.ToString + "<br />")))
        End Select
    End Sub

#End Region

#Region "Render Override"

    ' Register the dynamically created client scripts
    Protected Overrides Sub Render(ByVal writer As HtmlTextWriter)
        ' The client scripts for GridView1 were created in GridView1_RowDataBound
        For Each r As GridViewRow In GridView1.Rows
            If (r.RowType = DataControlRowType.DataRow) Then
                Dim cellIndex As Integer = 2
                Do While (cellIndex < r.Cells.Count)
                    Page.ClientScript.RegisterForEventValidation((r.UniqueID + "$ctl00"), cellIndex.ToString)
                    Page.ClientScript.RegisterForEventValidation((r.UniqueID + "$ctl01"), cellIndex.ToString)
                    cellIndex = (cellIndex + 1)
                Loop
            End If
        Next
        ' The client scripts for DataList1 were created in DataList1_ItemDataBound
        For Each i As DataListItem In DataList1.Items
            If ((i.ItemType = ListItemType.Item) _
                        OrElse ((i.ItemType = ListItemType.AlternatingItem) _
                        OrElse (i.ItemType = ListItemType.SelectedItem))) Then
                Page.ClientScript.RegisterForEventValidation((i.UniqueID + "$LinkButton1"))
                Page.ClientScript.RegisterForEventValidation((i.UniqueID + "$LinkButton2"))
            End If
        Next
        MyBase.Render(writer)
    End Sub

#End Region

#Region "GetData"

    ' Some data to bind to the Gridview and DataList
    Private Function GetData() As DataTable
        Dim dt As DataTable = New DataTable
        dt.Columns.Add(New DataColumn("Id", GetType(System.Int32)))
        dt.Columns.Add(New DataColumn("Task", GetType(System.String)))
        dt.Columns.Add(New DataColumn("IsDone", GetType(System.Boolean)))
        dt.Rows.Add(New Object() {0, "Create a new project", True})
        dt.Rows.Add(New Object() {1, "Build a demo applcation", True})
        dt.Rows.Add(New Object() {2, "Test the demo applcation", True})
        dt.Rows.Add(New Object() {3, "Deploy the demo applcation", False})
        dt.Rows.Add(New Object() {4, "Support the demo applcation", False})
        Return dt
    End Function

#End Region

End Class
